helpdesk/urls.py
"""
lanshark-helpdesk - A Django powered ticket tracker for small enterprise.

(c) Copyright 2008 Jutda. All Rights Reserved. See LICENSE for details.

urls.py - Mapping of URL's to our various views. Note we always used NAMED
          views for simplicity in linking later on.
"""

from django.conf.urls import url
from django.contrib.auth.decorators import login_required
from django.contrib.auth import views as auth_views
from django.views.generic import TemplateView

from helpdesk import settings as helpdesk_settings
from helpdesk.views import feeds, staff, public, kb


class DirectTemplateView(TemplateView):
    extra_context = None

    def get_context_data(self, **kwargs):
        context = super(self.__class__, self).get_context_data(**kwargs)
        if self.extra_context is not None:
            for key, value in self.extra_context.items():
                if callable(value):
                    context[key] = value()
                else:
                    context[key] = value
        return context

app_name = 'helpdesk'

urlpatterns = [
    url(r'^dashboard/$',
        staff.dashboard,
        name='dashboard'),

    url(r'^tickets/$',
        staff.ticket_list,
        name='list'),

    url(r'^tickets/update/$',
        staff.mass_update,
        name='mass_update'),

    url(r'^tickets/submit/$',
        staff.create_ticket,
        name='submit'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/$',
        staff.view_ticket,
        name='view'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/followup_edit/(?P<followup_id>[0-9]+)/$',
        staff.followup_edit,
        name='followup_edit'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/followup_delete/(?P<followup_id>[0-9]+)/$',
        staff.followup_delete,
        name='followup_delete'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/edit/$',
        staff.edit_ticket,
        name='edit'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/update/$',
        staff.update_ticket,
        name='update'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/delete/$',
        staff.delete_ticket,
        name='delete'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/hold/$',
        staff.hold_ticket,
        name='hold'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/unhold/$',
        staff.unhold_ticket,
        name='unhold'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/cc/$',
        staff.ticket_cc,
        name='ticket_cc'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/cc/add/$',
        staff.ticket_cc_add,
        name='ticket_cc_add'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/cc/delete/(?P<cc_id>[0-9]+)/$',
        staff.ticket_cc_del,
        name='ticket_cc_del'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/dependency/add/$',
        staff.ticket_dependency_add,
        name='ticket_dependency_add'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/dependency/delete/(?P<dependency_id>[0-9]+)/$',
        staff.ticket_dependency_del,
        name='ticket_dependency_del'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/attachment_delete/(?P<attachment_id>[0-9]+)/$',
        staff.attachment_del,
        name='attachment_del'),

    url(r'^raw/(?P<type>\w+)/$',
        staff.raw_details,
        name='raw'),

    url(r'^rss/$',
        staff.rss_list,
        name='rss_index'),

    url(r'^reports/$',
        staff.report_index,
        name='report_index'),

    url(r'^reports/(?P<report>\w+)/$',
        staff.run_report,
        name='run_report'),

    url(r'^save_query/$',
        staff.save_query,
        name='savequery'),

    url(r'^delete_query/(?P<id>[0-9]+)/$',
        staff.delete_saved_query,
        name='delete_query'),

    url(r'^settings/$',
        staff.user_settings,
        name='user_settings'),

    url(r'^ignore/$',
        staff.email_ignore,
        name='email_ignore'),

    url(r'^ignore/add/$',
        staff.email_ignore_add,
        name='email_ignore_add'),

    url(r'^ignore/delete/(?P<id>[0-9]+)/$',
        staff.email_ignore_del,
        name='email_ignore_del'),
]

urlpatterns += [
    url(r'^$',
        login_required(public.homepage),
        name='home'),

    url(r'^view/$',
        login_required(public.view_ticket),
        name='public_view'),

    url(r'^change_language/$',
        public.change_language,
        name='public_change_language'),
]

urlpatterns += [
    url(r'^rss/user/(?P<user_name>[^/]+)/$',
        login_required(feeds.OpenTicketsByUser()),
        name='rss_user'),

    url(r'^rss/user/(?P<user_name>[^/]+)/(?P<queue_slug>[A-Za-z0-9_-]+)/$',
        login_required(feeds.OpenTicketsByUser()),
        name='rss_user_queue'),

    url(r'^rss/queue/(?P<queue_slug>[A-Za-z0-9_-]+)/$',
        login_required(feeds.OpenTicketsByQueue()),
        name='rss_queue'),

    url(r'^rss/unassigned/$',
        login_required(feeds.UnassignedTickets()),
        name='rss_unassigned'),

    url(r'^rss/recent_activity/$',
        login_required(feeds.RecentFollowUps()),
        name='rss_activity'),
]


urlpatterns += [
    url(r'^login/$',
        auth_views.login,
        {'template_name': 'helpdesk/registration/login.html'},
        name='login'),

    url(r'^logout/$',
        auth_views.logout,
        {'template_name': 'helpdesk/registration/login.html', 'next_page': '../'},
        name='logout'),
]

if helpdesk_settings.HELPDESK_KB_ENABLED:
    urlpatterns += [
        url(r'^kb/$',
            kb.index,
            name='kb_index'),

        url(r'^kb/(?P<item>[0-9]+)/$',
            kb.item,
            name='kb_item'),

        url(r'^kb/(?P<item>[0-9]+)/vote/$',
            kb.vote,
            name='kb_vote'),

        url(r'^kb/(?P<slug>[A-Za-z0-9_-]+)/$',
            kb.category,
            name='kb_category'),
    ]

urlpatterns += [
    url(r'^help/context/$',
        TemplateView.as_view(template_name='helpdesk/help_context.html'),
        name='help_context'),

    url(r'^system_settings/$',
        DirectTemplateView.as_view(template_name='helpdesk/system_settings.html'),
        name='system_settings'),
]

helpdesk/templates/helpdesk/attribution.html
{% load i18n %}

<a href="/">Home</a> {% trans "footer" %}.

helpdesk/templates/helpdesk/base.html
{% load i18n %}
{% load saved_queries %}
{% load load_helpdesk_settings %}
{% load static from staticfiles %}
{% with request|load_helpdesk_settings as helpdesk_settings %}
{% with user|saved_queries as user_saved_queries_ %}
<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>{% block helpdesk_title %}Helpdesk{% endblock %} :: {% trans "Powered by lanshark-helpdesk" %}</title>

    <!-- Bootstrap Core CSS -->
    {% if helpdesk_settings.HELPDESK_USE_CDN %}
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    {% else %}
    <link href="{% static 'helpdesk/vendor/bootstrap/css/bootstrap.min.css' %}" rel="stylesheet">
    {% endif %}

    <!-- MetisMenu CSS -->
    <link href="{% static 'helpdesk/vendor/metisMenu/metisMenu.min.css' %}" rel="stylesheet">

    <!-- Morris Charts CSS -->
    {% if helpdesk_settings.HELPDESK_USE_CDN %}
    <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/morris.js/0.5.1/morris.css">
    {% else %}
    <link href="{% static 'helpdesk/vendor/morrisjs/morris.css' %}" rel="stylesheet">
    {% endif %}

    <!-- DataTables CSS -->
    <link href="{% static 'helpdesk/vendor/datatables/css/dataTables.bootstrap.min.css' %}" rel="stylesheet">
    <link href="{% static 'helpdesk/vendor/datatables/extensions/Responsive/css/responsive.bootstrap.min.css' %}" rel="stylesheet">

    <!-- Custom CSS -->
    <link href="{% static 'helpdesk/dist/css/sb-admin-2.css' %}" rel="stylesheet">
    <link rel='stylesheet' href='{% static "helpdesk/helpdesk-extend.css" %}' type='text/css'  media="screen" >

    <!-- Custom Fonts -->
    <link href="{% static 'helpdesk/vendor/font-awesome/css/font-awesome.min.css' %}" rel="stylesheet" type="text/css">

    <!-- jQuery -->
    {% if helpdesk_settings.HELPDESK_USE_CDN %}
    <script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.0/jquery.min.js"></script>
    {% else %}
    <script src="{% static 'helpdesk/vendor/jquery/jquery.min.js' %}"></script>
    {% endif %}

    <!-- jQuery UI DatePicker -->
    <script src='{% static "helpdesk/vendor/jquery-ui/jquery-ui.min.js" %}' type='text/javascript' language='javascript'></script>
    <link href="{% static 'helpdesk/vendor/jquery-ui/jquery-ui.css' %}" rel="stylesheet">

    <!-- Bootstrap Core JavaScript -->
    {% if helpdesk_settings.HELPDESK_USE_CDN %}
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
    {% else %}
    <script src="{% static 'helpdesk/vendor/bootstrap/js/bootstrap.min.js' %}"></script>
    {% endif %}

    <!-- DataTables JavaScript -->
    <script src="{% static 'helpdesk/vendor/datatables/js/jquery.dataTables.min.js' %}"></script>
    <script src="{% static 'helpdesk/vendor/datatables/js/dataTables.bootstrap.min.js' %}"></script>
    <script src="{% static 'helpdesk/vendor/datatables/extensions/Responsive/js/dataTables.responsive.min.js' %}"></script>

    <!-- Custom Theme JavaScript -->
    <script src="{% static 'helpdesk/dist/js/sb-admin-2.js' %}"></script>

    <!-- RSS -->
    <link rel='alternate' href='{% url 'helpdesk:rss_user' user.get_username %}' type='application/rss+xml' title='{% trans "My Open Tickets" %}' />
    <link rel='alternate' href='{% url 'helpdesk:rss_activity' %}' type='application/rss+xml' title='{% trans "All Recent Activity" %}' />
    <link rel='alternate' href='{% url 'helpdesk:rss_unassigned' %}' type='application/rss+xml' title='{% trans "Unassigned Tickets" %}' />

    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
        <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
        <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
    <![endif]-->

    <style type="text/css">
    /* hide google translate top bar */
    .goog-te-banner-frame {display: none !important;}
    .goog-te-balloon-frame {display: none !important;}
    /* hide google translate tooltips (generated for every translated item) */
    .goog-tooltip {display: none !important; }
    </style>

    <style type="text/css">
    /* header */
    #dropdown li.headerlink { width: auto; float: left; text-align: center; }

    /* query list */
    #dropdown li.headerlink ul {    display: none;
                                    text-align: left;
                                    position: absolute;
                                    padding: 5px;
                                    z-index: 2; }
    /* query entries */
    #dropdown li.headerlink:hover ul { display: block; width: auto; }
    #dropdown li.headerlink:hover ul li { padding: 5px; margin: 1px; float: none; display: block; }
    </style>

    {% block helpdesk_head %}{% endblock %}

</head>

<body id="helpdesk-body">

    <div id='container' class="container">
        <div id='header' class="row">
            <h1>{% block h1_title %}{% trans "Helpdesk" %}{% endblock %}</h1>
            {% include "helpdesk/navigation.html" %}
        </div>

        <div id='body' class="row">
            {% block helpdesk_body %}{% endblock %}
        </div>

        <div id='footer' class="row">
            <div class="col-md-2">{% include "helpdesk/attribution.html" %}</div>
        </div>
    </div>
    {% include "helpdesk/debug.html" %}

    <!-- Metis Menu Plugin JavaScript -->
    <script src="{% static 'helpdesk/vendor/metisMenu/metisMenu.min.js' %}"></script>

    <!-- Custom Theme JavaScript -->
    <script src="{% static 'helpdesk/dist/js/sb-admin-2.js' %}"></script>

</body>
</html>
{% endwith %}
{% endwith %}

helpdesk/templates/helpdesk/edit_ticket.html
{% extends "helpdesk/base.html" %}{% load i18n bootstrap %}

{% block helpdesk_title %}{% trans "Edit Ticket" %}{% endblock %}

{% block helpdesk_body %}
<div class="col-xs-6">
<div class="panel panel-default">

<div class="panel-body"><h2>{% trans "Edit a Ticket" %}</h2>

<p>{% trans "Unless otherwise stated, all fields are required." %} {% trans "Please provide as descriptive a title and description as possible." %}</p>

<p><strong>{% trans "Note" %}:</strong> {% blocktrans %}Editing a ticket does <em>not</em> send an e-mail to the ticket owner or submitter. No new details should be entered, this form should only be used to fix incorrect details or clean up the submission.{% endblocktrans %}</p>

<form method='post' action='./'>
<fieldset>
    {{ form|bootstrap }}
    {% comment %}
        {% for field in form %}
            {% if field.is_hidden %}
                {{ field }}
            {% else %}
                <dt><label for='id_{{ field.name }}'>{{ field.label }}</label>{% if not field.field.required %} <span class='form_optional'>{% trans "(Optional)" %}</span>{% endif %}</dt>
                <dd>{{ field }}</dd>
                {% if field.errors %}<dd class='error'>{{ field.errors }}</dd>{% endif %}
                {% if field.help_text %}<dd class='form_help_text'>{{ field.help_text }}</dd>{% endif %}</label>
            {% endif %}
        {% endfor %}
    </dl>
    {% endcomment %}
    <div class='buttons form-group'>
        <input type='submit' class="btn btn-primary" value='{% trans "Save Changes" %}' />
    </div>
</fieldset>

{% csrf_token %}</form>
    </div>
  </div>
</div>
{% endblock %}

helpdesk/templates/helpdesk/rss_list.html
{% extends "helpdesk/base.html" %}{% load i18n %}
{% load static from staticfiles %}
{% block helpdesk_title %}{% trans "RSS Feeds" %}{% endblock %}
{% block helpdesk_body %}
<h2>{% trans "RSS Feeds" %}</h2>

<p>{% trans "The following RSS feeds are available for you to monitor using your preferred RSS software. With the exception of the 'Latest Activity' feed, all feeds provide information only on Open and Reopened cases. This ensures your RSS reader isn't full of information about closed or historical tasks." %}</p>

<dl>
    <dt><a href='{% url 'helpdesk:rss_user' user.get_username %}'><i class="fa fa-rss-square fa-fw"></i>{% trans "My Open Tickets" %}</a></dt>
    <dd>{% trans "A summary of your open tickets - useful for getting alerted to new tickets opened for you" %}</dd>

    <dt><a href='{% url 'helpdesk:rss_activity' %}'><i class="fa fa-rss-square fa-fw"></i>{% trans "Latest Activity" %}</a></dt>
    <dd>{% trans "A summary of all helpdesk activity - including comments, emails, attachments, and more" %}</dd>

    <dt><a href='{% url 'helpdesk:rss_unassigned' %}'><i class="fa fa-rss-square fa-fw"></i>{% trans "Unassigned Tickets" %}</a></dt>
    <dd>{% trans "All unassigned tickets - useful for being alerted to new tickets opened by the public via the web or via e-mail" %}</dd>
</dl>

<p>{% trans "These RSS feeds allow you to view a summary of either your own tickets, or all tickets, for each of the queues in your helpdesk. For example, if you manage the staff who utilise a particular queue, this may be used to view new tickets coming into that queue." %}</p>

            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-primary">
                        <header class="panel-heading">
                            {% trans "Per-Queue Feeds" %}
                        </header>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div class="table-responsive">
                                <table class="table table-striped table-bordered table-hover">
                                    <thead>
                                        <tr>
                                            <th>{% trans "Queue" %}</th>
                                            <th align='center'>{% trans "All Open Tickets" %}</th>
                                            <th align='center'>{% trans "My Open Tickets" %}</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {% for queue in queues %}
                                        <tr>
                                            <td>{{ queue.title }}</td>
                                            <td align='center'><a href='{% url 'helpdesk:rss_queue' queue.slug %}'><i class="fa fa-rss-square fa-fw"></i></a></td>
                                            <td align='center'><a href='{% url 'helpdesk:rss_user_queue' user.get_username queue.slug %}'><i class="fa fa-rss-square fa-fw"></i></a></td>
                                        </tr>
                                        {% endfor %}
                                    </tbody>
                                </table>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <!-- /.row -->

{% endblock %}

helpdesk/templates/helpdesk/ticket_cc_list.html
{% extends "helpdesk/base.html" %}{% load i18n %}

{% block helpdesk_title %}{% trans "Ticket CC Settings" %}{% endblock %}

{% block helpdesk_body %}{% blocktrans with ticket.title as ticket_title and ticket.id as ticket_id %}
<h2>Ticket CC Settings</h2>

<p>The following people will receive an e-mail whenever <em><a href='../'>{{ ticket_title }}</a></em> is updated. Some people can also view or edit the ticket via the public ticket views.</p>

<p>You can add a new recipient to the list or delete any of the items below as required.</p>{% endblocktrans %}

            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-primary">
                        <div class="panel-heading">
                            {% trans "Ticket CC List" %}
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div><a href='add/'><button class="btn btn-success btn-sm"><i class="fa fa-plus-circle"></i>{% trans "Add an Email or Helpdesk User" %}</button></a></div>
                            <div class="table-responsive">
                                <table class="table table-striped table-bordered table-hover">
                                    <thead>
                                        <tr>
                                            <th>{% trans "E-Mail Address or Helpdesk User" %}</th>
                                            <th>{% trans "View?" %}</th>
                                            <th>{% trans "Update?" %}</th>
                                            <th>{% trans "Delete" %}</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {% for person in copies_to %}
                                        <tr class='row_{% cycle 'odd' 'even' %}'>
                                            <td>{{ person.display }}</td>
                                            <td>{{ person.can_view }}</td>
                                            <td>{{ person.can_update }}</td>
                                            <td><a href='{% url 'helpdesk:ticket_cc_del' ticket.id person.id %}'><button class="btn btn-danger btn-xs">{% trans "Delete" %}</button></a></td>
                                        </tr>
                                        {% endfor %}
                                    </tbody>
                                </table>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <!-- /.row -->

<p><a href='{% url 'helpdesk:view' ticket.id %}'><button class="btn btn-primary btn-lg">{% blocktrans with ticket.title as ticket_title %}Return to <em>{{ ticket_title }}</em>{% endblocktrans %}</button></a></p>

{% endblock %}

helpdesk/templates/helpdesk/ticket_desc_table.html
{% load i18n humanize %}
{% load static from staticfiles %}

<div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-primary">
                        <div class="panel-heading">
                            {% trans "Ticket Summary" %}
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div class="table-responsive">
                                <table class="table table-striped table-bordered table-hover">
                                    <thead>
                                        <tr class='row_tablehead'><td colspan='2'><h3>{{ ticket.id }}. {{ ticket.title }} [{{ ticket.get_status }}]</h3> <span class='ticket_toolbar'>
                                            <a href="{% url 'helpdesk:edit' ticket.id %}" class="ticket-edit"><button class="btn btn-warning btn-xs"><i class="fa fa-pencil"></i> {% trans "Edit" %}</button></a>
                                        | <a href="{% url 'helpdesk:delete' ticket.id %}" class="ticket-delete"><button class="btn btn-danger btn-xs"><i class="fa fa-trash-o"></i> {% trans "Delete" %}</button></a>
                                        {% if ticket.on_hold %} | <a href="{% url 'helpdesk:unhold' ticket.id %}" class="ticket-hold"><button class="btn btn-warning btn-xs"><i class="fa fa-play"></i> {% trans "Unhold" %}</button></a>{% else %} | <a href="{% url 'helpdesk:hold' ticket.id %}" class="ticket-hold"><button class="btn btn-warning btn-xs"><i class="fa fa-pause"></i> {% trans "Hold" %}</button></a>{% endif %}
                                        </span></td></tr>
                                    <tr><th colspan='2'>{% blocktrans with ticket.queue as queue %}Queue: {{ queue }}{% endblocktrans %}</th></tr>
                                    </thead>
                                    <tbody>
                                        {% for customfield in ticket.ticketcustomfieldvalue_set.all %}
                                        <tr>
                                            <th>{{ customfield.field.label }}</th>
                                            <td>{% ifequal customfield.field.data_type "url" %}<a href='{{ customfield.value }}'>{{ customfield.value }}</a>{% else %}{{ customfield.value }}{% endifequal %}</td>
                                        </tr>{% endfor %}
                                        <tr>
                                            <th colspan='2'>{% trans "Description" %}</th>
                                        </tr>
                                        <tr>
                                            <td id="ticket-description" colspan='2'>{{ ticket.description|force_escape|urlizetrunc:50|linebreaksbr }}</td>
                                        </tr>

                                        {% if ticket.resolution %}<tr>
                                            <th colspan='2'>{% trans "Resolution" %}{% ifequal ticket.get_status_display "Resolved" %} <a href='?close'><button type="button" class="btn btn-warning btn-xs">{% trans "Accept and Close" %}</button></a>{% endifequal %}</th>
                                        </tr>
                                        <tr>
                                            <td colspan='2'>{{ ticket.resolution|force_escape|urlizetrunc:50|linebreaksbr }}</td>
                                        </tr>{% endif %}
                                        <tr>
                                            <th>{% trans "Submitted On" %}</th>
                                            <td>{{ ticket.created|date:"r" }} ({{ ticket.created|naturaltime }})</td>
                                        </tr>

                                        <tr>
                                            <th>{% trans "Assigned To" %}</th>
                                            <td>{{ ticket.get_assigned_to }}{% ifequal ticket.get_assigned_to _('Unassigned') %} <strong><a href='?take'><button type="button" class="btn btn-primary btn-xs"><i class="fa fa-hand-paper-o"></i>&nbsp;{% trans "Take" %}</button></a></strong>{% endifequal %}</td>
                                        </tr>

                                        <tr>
                                            <th>{% trans "Submitter E-Mail" %}</th>
                                            <td>{{ ticket.submitter_email }}{% if user.is_superuser %} <strong><a href='{% url 'helpdesk:email_ignore_add' %}?email={{ ticket.submitter_email }}'><button type="button" class="btn btn-warning btn-xs"><i class="fa fa-eye-slash"></i>&nbsp;{% trans "Ignore" %}</button></a></strong>{% endif %}</td>
                                        </tr>

                                        <tr>
                                            <th>{% trans "Priority" %}</th>
                                            <td>{{ ticket.get_priority_display }}</td>
                                        </tr>

                                        <tr>
                                            <th>{% trans "Copies To" %}</th>
                                            <td>{{ ticketcc_string }} <a data-toggle='tooltip' href='{% url 'helpdesk:ticket_cc' ticket.id %}' title='{% trans "Click here to add / remove people who should receive an e-mail whenever this ticket is updated." %}'><strong><button type="button" class="btn btn-warning btn-xs"><i class="fa fa-share"></i>&nbsp;{% trans "Manage" %}</button></strong></a>{% if SHOW_SUBSCRIBE %}, <strong><a data-toggle='tooltip' href='?subscribe' title='{% trans "Click here to subscribe yourself to this ticket, if you want to receive an e-mail whenever this ticket is updated." %}'><button type="button" class="btn btn-warning btn-xs"><i class="fa fa-rss"></i>&nbsp;{% trans "Subscribe" %}</button></a></strong>{% endif %}</td>
                                        </tr>

                                        <tr>
                                            <th>{% trans "Dependencies" %}</th>
                                            <td>{% for dep in ticket.ticketdependency.all %}
                                                {% if forloop.first %}<p>{% trans "This ticket cannot be resolved until the following ticket(s) are resolved" %}</p><ul>{% endif %}
                                                    <li><a href='{{ dep.depends_on.get_absolute_url }}'>{{ dep.depends_on.ticket }} {{ dep.depends_on.title }}</a> ({{ dep.depends_on.get_status_display }}) <a href='{% url 'helpdesk:ticket_dependency_del' ticket.id dep.id %}'><button type="button" class="btn btn-warning btn-xs"><i class="fa fa-trash"></i>&nbsp;{% trans "Remove Dependency" %}</button></a></li>
                                                {% if forloop.last %}</ul>{% endif %}
                                                {% empty %}
                                                <p>{% trans "This ticket has no dependencies." %}</p>
                                                {% endfor %}
                                                <p><a data-toggle='tooltip' href='{% url 'helpdesk:ticket_dependency_add' ticket.id %}' title="{% trans "Click on 'Add Dependency', if you want to make this ticket dependent on another ticket. A ticket may not be closed until all tickets it depends on are closed." %}"><button type="button" class="btn btn-primary btn-xs"><i class="fa fa-child"></i>&nbsp;{% trans "Add Dependency" %}</button></a></p>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
            </div>